<?
/*

input: $percent

*/

function translate_hex ($hexcode) {
	$red = hexdec(substr($hexcode, 0, 2));
	$green = hexdec(substr($hexcode, 2, 2));
	$blue = hexdec(substr($hexcode, 4, 2));
	return array($red, $green, $blue);
}

function pic_error_msg ($message) {
	Header('Content-Type: image/gif');
	$im  = imagecreatetruecolor(300, 25); // Create a blank image
	$bgc = imagecolorallocate($im, 255, 255, 255);
	$tc  = imagecolorallocate($im, 0, 0, 0);
	imagefilledrectangle($im, 0, 0, 300, 25, $bgc);
	// Output an errmsg
	imagestring($im, 3, 5, 5, $message, $tc);
	imageGIF($im);
	imagedestroy($im);
}

$percent = $_GET["percent"];
$colour1 = $_GET["colour1"];
$colour2 = $_GET["colour2"];
$colour3 = $_GET["colour3"];
$colour4 = $_GET["colour4"];
$font_colour = $_GET["font_colour"];
$picture = $_GET["pict"];

// check to make sure it's the right filetype
$pict_array = explode('.', $picture);
$type = strtolower(end($pict_array)); // jpeg, jpg, gif or png
if ($type == 'jpg') { $type = 'jpeg'; }

$allowed = array('jpeg', 'png', 'gif');
if (!in_array($type, $allowed)) {
	echo 'Error loading '.$picture.', wrong filetype';
	return;
}

$image_loc = 'images/'.$picture;
if ($type == 'png') {
	$image = @imageCreateFromPNG($image_loc); }
elseif ($type == 'jpeg') {
	$image = @imageCreateFromJPEG($image_loc); }
else {
	$image = @imageCreateFromGIF($image_loc); }

if (!$image) {
	echo 'Error loading '.$picture;
	return;
}

imageSaveAlpha($image, true);

$size = getimagesize($image_loc);

$height = 14;
$top = ($size[1] / 2) - 7; // 7
$left = ($size[0] / 2) - 50; // 8
$fontsize = 10;
$font = 'ArialBold.ttf';

$word_col_array = translate_hex ($font_colour);
//$word_col = ImageColorAllocate ($image, 51, 0, 51);
$word_col = ImageColorAllocate ($image,
								$word_col_array[0],
								$word_col_array[1],
								$word_col_array[2]);
$word_shift = 0;

if ($percent < 25) {
	//$col = ImageColorAllocate ($image, 101, 63, 144);
	$col_array = translate_hex ($colour1);
	$col = ImageColorAllocate ($image,
							   $col_array[0],
							   $col_array[1],
							   $col_array[2]);
	if ($percent < 10) {
		$word_shift = '5';
	}
} elseif ($percent < 50) {
	//$col = ImageColorAllocate ($image, 51, 153, 153);
	$col_array = translate_hex ($colour2);
	$col = ImageColorAllocate ($image,
							   $col_array[0],
							   $col_array[1],
							   $col_array[2]);
} elseif ($percent < 75) {
	//$col = ImageColorAllocate ($image, 252, 184, 158);
	$col_array = translate_hex ($colour3);
	$col = ImageColorAllocate ($image,
							   $col_array[0],
							   $col_array[1],
							   $col_array[2]);
} else {
	//$col = ImageColorAllocate ($image, 255, 221, 236);
	$col_array = translate_hex ($colour4);
	$col = ImageColorAllocate ($image,
							   $col_array[0],
							   $col_array[1],
							   $col_array[2]);
	if ($percent >= 100) {
		$percent = 100;
		$word_shift = '-5';
	}
}

imagefilledrectangle($image, $left, $top, $left + $percent, $top + $height, $col);
imagefttext($image, $fontsize, 0, 42 + $left + $word_shift, 12 + $top, $word_col, $font, $percent.'%');

Header ('Content-type: image/'.$type);

if ($type == 'png') {
	$image = imagePNG($image); }
elseif ($type == 'jpeg') {
	$image = imageJPEG($image); }
else {
	$image = imageGIF($image); }
	
imagedestroy($image);

?>